/***************************************************************************
                          export.cpp  -  description
                             -------------------
    begin                : Sun Nov 18 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <export_formate.h>

#include <string.h>
#include <stdlib.h>

// include files for Qt
#include <qdir.h>
#include <qwidget.h>
#include <qmessagebox.h>
#include <qfiledialog.h>
#include <qprogressdialog.h>

#include <iostream>
#include <iomanip>


ExportObj::ExportObj(QWidget *parent, const char *name=0)
{
	exportformat = 0;
	exportFilename = new QString("/tmp/SqlGuiExport.tmp");
	exportTablename = new QString("");
	DBType = 0;
	rowOffset=0;
 	columnOffset=0;
	zellExport = NULL;
	last = NULL;
}

void ExportObj::doExport()
{

}

void ExportObj::setFormat(int x)
{
	exportformat = x;
	// std::cout << "Format: " << exportformat << endl;
}

void ExportObj::setTablename(const QString * tbname)
{
	exportTablename->setLatin1( tbname->latin1() );
}

void ExportObj::setDBType(int t)
{
	DBType = t;
}

void ExportObj::setFilename(const QString * filename)
{
	exportFilename->setLatin1( filename->latin1() );
	cells=0;
	// std::cout << "File: " << filename->latin1() << endl;
}

void ExportObj::addData(int row, int col, QString* data, QString* dtype)
{
//	// std::cout << "(" << row << "," << col << ") " << data->latin1() << endl;
	
	cells++;
	cell_t * zelle = new cell_t;
	
//	datastring = new char[ data->length() + 1 ];
//    if( (!data->isNull() ) && (!data->isEmpty()) ){
//  	  strcpy( datastring, data->latin1() );
//    } else {
//    	strcpy( datastring, "" );
//    }
	

 dtypestring = new char[ dtype->length() + 1 ];
    if(dtype){
        if( (!dtype->isNull() ) && (!dtype->isEmpty()) ){
         	  strcpy( dtypestring, dtype->latin1() );
        } else {
           	strcpy( dtypestring, "" );
        }
    } else {
         dtypestring = "";
    }
	zelle->col=col;
	zelle->row=row;
	zelle->next=NULL;
//    zelle->data=datastring;
    QString * d = new QString(*data);
    zelle->data=d;
    zelle->datatype=dtypestring;
	cell_t * temp = NULL;

	if (zellExport == NULL) {
		zellExport=zelle;
		last = zellExport;
	} else {
		last->next = zelle;
		last = last->next;
	}
}

void ExportObj::finish()
{
// Jetzt wird das eigentliche Export-Modul aufgerufen,
// welches die Daten in das richtige Fileformat bringt...
			
	QString label = QString("Now exporting data, please wait...");
	QString cancel = QString("Abort export");
	int tot = cells;
	
	QProgressDialog progress( label, cancel, tot, NULL, NULL, TRUE, 0 );
	int howmuch = 0;
			
	switch (exportformat)
	{
		case EXCEL:
		{
		
			// std::cout << "Now creating Excel-file" << endl;
			ExportObj_EXCEL * exp = new ExportObj_EXCEL( (QWidget*) this );
			exp->setFilename(exportFilename);

			cell_t * temp = NULL;
			temp = zellExport;
			
			while(temp)
			{
				exp->addData( temp->row, temp->col, temp->data, temp->datatype );
				temp=temp->next;
				progress.setProgress( howmuch++ );
				if (progress.wasCancelled() ) temp = NULL;
			}
			
			exp->finish();
			
			break;
			
		}
		case TEXT:
		{
		
			// std::cout << "Now creating Text-file" << endl;
			ExportObj_TEXT * exp = new ExportObj_TEXT((QWidget*) this );
			exp->setFilename(exportFilename);

			cell_t * temp = NULL;
			temp = zellExport;
				
			while(temp)
			{
				exp->addData( temp->row, temp->col, temp->data, temp->datatype );
				temp=temp->next;
				progress.setProgress( howmuch++ );
				if (progress.wasCancelled() ) temp = NULL;
			}
			
			exp->finish();
						
			break;
			
		}
		case CSV:
		{
		
			// std::cout << "Now creating Text-file" << endl;
			ExportObj_CSV * exp = new ExportObj_CSV((QWidget*) this );
			exp->setFilename(exportFilename);

			cell_t * temp = NULL;
			temp = zellExport;

			while(temp)
			{
				exp->addData( temp->row, temp->col, temp->data, temp->datatype );
				temp=temp->next;
				progress.setProgress( howmuch++ );
				if (progress.wasCancelled() ) temp = NULL;
			}
			
			exp->finish();
			
			break;
			
		}
		case XML:
		{
		
			// std::cout << "Now creating XML-file" << endl;
			ExportObj_XML * exp = new ExportObj_XML((QWidget*) this);
			exp->setFilename(exportFilename);
      exp->setTablename(exportTablename);
      exp->setDBType( DBType );

			cell_t * temp = NULL;
			temp = zellExport;
			
			while(temp)
			{
				exp->addData( temp->row, temp->col, temp->data, temp->datatype );
				temp=temp->next;
				progress.setProgress( howmuch++ );
				if (progress.wasCancelled() ) temp = NULL;
			}

			exp->setRowOffset( rowOffset );
   		exp->setColumnOffset( columnOffset );
			exp->finish();
			
			break;
		}
		case HTML:
		{
		
			// std::cout << "Now creating Text-file" << endl;
			ExportObj_HTML * exp = new ExportObj_HTML((QWidget*) this );
			exp->setFilename(exportFilename);

			cell_t * temp = NULL;
			temp = zellExport;
			
			while(temp)
			{
				exp->addData( temp->row, temp->col, temp->data, temp->datatype );
				temp=temp->next;
				progress.setProgress( howmuch++ );
				if (progress.wasCancelled() ) temp = NULL;
			}
			
			exp->finish();
			
			break;
		}
		default: return;
	}
	progress.setProgress( cells );
}

void ExportObj::setRowOffset(int r){
	rowOffset=r;
}

void ExportObj::setColumnOffset(int c){
	columnOffset=c;
}