/***************************************************************************
                          export_excel.cpp  -  description
                             -------------------
    begin                : Mon Nov 19 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
	Vorerst gehen wir davon aus, da die Daten bereits sortiert bergeben werden.
*/


#include <stdlib.h>
#include <export_html.h>
#include <qfile.h>

#include <iostream>
#include <iomanip>

ExportObj_HTML::ExportObj_HTML(QWidget *parent, const char *name)
{
	exportFilename = new QString("/tmp/SqlGuiExport.tmp");
	exportData = NULL;
	last = NULL;
}

void ExportObj_HTML::setFilename(const QString * filename)
{
	exportFilename->setLatin1( filename->latin1() );
	exportData=NULL;
	last = NULL;
}

//void ExportObj_HTML::addData(int row, int col, const char * data, const char * dtype="")
void ExportObj_HTML::addData(int row, int col, QString * data, const char * dtype)
{
	cell_t * temp = new cell_t;
	temp->row = row;
	temp->col = col;
//	char * datastring = new char[ strlen(data) +1 ];
//  strcpy( datastring, data );
//	temp->data = datastring;
    QString * d = new QString(*data);
    temp->data = d;

	temp->next = NULL;
	
	if( exportData == NULL )
	{
		exportData = temp;
		last = exportData;
	}
	else
	{
	
		last->next = temp;
		last = last->next;
	
//		cell_t * temp2 = exportData;
//		while(temp2->next)
//		{
//			temp2 = temp2->next;
//		}
//		temp2->next = temp;
	}
	
}

void ExportObj_HTML::finish()
{

// std::cout << "ToDo: Entitiy-Encoding for export file..." << endl;

QString tmpname = *(exportFilename);
QFile file(tmpname);
file.open(IO_WriteOnly);
		
QString * header = new QString("<html><head><title>SqlGui Export</title></head><body><h1>SqlGui-Export</h1><table><tr>");
file.writeBlock( header->latin1(), header->length() );

cell_t * temp = exportData;
int oldrow = 0;
int row = 0;

while(temp){
	row = temp->row;
	if (row > oldrow)
	{
		file.writeBlock( "</tr>\n<tr>", 10);
		oldrow = row;
	}
	file.writeBlock( "<td>", 4 );
//	file.writeBlock( temp->data, strlen( temp->data ) );
	file.writeBlock( temp->data->latin1(), temp->data->length() );	
	file.writeBlock( "</td>", 5 );
	temp = temp->next;
}

QString * footer = new QString("</tr></table></body></html>");
file.writeBlock( footer->latin1(), footer->length() );

file.close();
}
