/***************************************************************************
                          export_excel.cpp  -  description
                             -------------------
    begin                : Mon Nov 19 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
	Vorerst gehen wir davon aus, da die Daten bereits sortiert bergeben werden.
*/


#include <stdlib.h>
#include <export_xml.h>
#include <qfile.h>
#include <qcstring.h>

#include <iostream>
#include <iomanip>

#include "dbtypes.h"

ExportObj_XML::ExportObj_XML(QWidget *parent, const char *name)
{
	exportFilename = new QString("/tmp/SqlGuiExport.tmp");
	exportData=NULL;
	exportTablename= new QString("");
	exportDBType = new QString("");
	last = NULL;
 	rowOffset = 0;
  columnOffset = 0;
}

void ExportObj_XML::setFilename(const QString * filename)
{
	exportFilename->setLatin1( filename->latin1() );
}

void ExportObj_XML::setTablename(const QString * tbname)
{
	exportTablename->setLatin1( tbname->latin1() );
}


void ExportObj_XML::setDBType(int t)
{
  switch(t){
    case SQLGUI_MYSQL:{
	    exportDBType->setLatin1( "mysql" );
      break;
    }
    case SQLGUI_PGSQL:{
	    exportDBType->setLatin1( "pgsql" );
      break;
    }
    case SQLGUI_SAPDB:{
	    exportDBType->setLatin1( "sapdb" );
      break;
    }
    case SQLGUI_IBMDB2:{
	    exportDBType->setLatin1( "ibmdb2" );
      break;
    }
    case SQLGUI_ORACLE:{
	    exportDBType->setLatin1( "oracle" );
      break;
    }
  }
}

//void ExportObj_XML::addData(int row, int col, const char * data, const char * dtype="")
void ExportObj_XML::addData(int row, int col, QString * data, const char * dtype)
{
	
	cell_t * temp = new cell_t;
	temp->row = row;
	temp->col = col;
//	char * datastring = new char[ strlen(data) +1 ];
//  strcpy( datastring, data );
    QString * d = new QString(*data);
    temp->data = d;
	char * dtypestring = new char[ strlen(dtype) +1 ];
    strcpy( dtypestring, dtype );
//    temp->data = datastring;
    temp->datatype = dtypestring;
	temp->next = NULL;
	
	if( exportData == NULL )
	{
		exportData = temp;
		last = exportData;
	}
	else
	{
	
		last->next = temp;
		last = last->next;
	
//		cell_t * temp2 = exportData;
//		while(temp2->next)
//		{
//			temp2 = temp2->next;
//		}
//		temp2->next = temp;
	}
	
}

void ExportObj_XML::finish()
{

//// std::cout << "ToDo: Entitiy-Encoding for export file..." << endl;
//// std::cout << "ToDo: DTD..." << endl;
//// std::cout << "ToDo: create good xml... ;)" << endl;

QString tmpname = *(exportFilename);
QFile file(tmpname);
file.open(IO_WriteOnly);

QString * header = new QString("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE database SYSTEM \"database.dtd\">\n<database type=\"");
header->append( *exportDBType );
header->append("\">\n<table name=\"");
header->append( *exportTablename );
header->append("\">\n<definition>\n<!-- ToDo: add the table-definition of the exported table, column-names, etc. -->\n</definition>\n<content rowoffset=\"");

QString ro;
ro.setNum(rowOffset);
QString co;
co.setNum(columnOffset);

header->append( ro );
header->append("\" columnoffset=\"");
header->append( co );
header->append("\">\n");

file.writeBlock( header->latin1(), header->length() );

cell_t * temp = exportData;
int oldrow = 0;
int row = 0;

while(temp){

	QString * opener = new QString( "<cell row=\"");
	opener->append( QString::number( temp->row ) );
	opener->append( "\" col=\"" );
	opener->append( QString::number( temp->col ) );
	opener->append( "\">\n");
	opener->append( "   <data " );
  opener->append( "type=\"");
	opener->append( QString( temp->datatype ) );		
    opener->append( "\">");

	file.writeBlock( opener->latin1(), opener->length() );

    QString * dat = new QString( *(temp->data) );
    int amps = dat->contains('&', true );
    int pos = 0;
    for( int i = 0; i < amps; i++){
         int newpos = dat->find('&',pos,true);
         dat->replace(newpos,1,"&amp;");
         pos = newpos;
    }

    QCString utf = dat->utf8();

	file.writeBlock( ( const char * ) utf, utf.length() );	

	file.writeBlock( "</data>\n</cell>\n", 16 );
	temp = temp->next;
}

QString * footer = new QString("</content></table></database>");
file.writeBlock( footer->latin1(), footer->length() );

file.close();
}

void ExportObj_XML::setRowOffset(int r){
  rowOffset = r;
}

void ExportObj_XML::setColumnOffset(int c){
  columnOffset=c;
}