/***************************************************************************
                          reporteditor.cpp  -  description
                             -------------------
    begin                : Wed Feb 26 2003
    copyright            : (C) 2003 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "reporteditor.h"
#include <qtable.h>
#include <qpushbutton.h>
#include <klocale.h>

reportEditor::reportEditor( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal=false, fl )
{

	if ( !name ){ setName( "reportEditor" ); }

	const QString catalogue = "sqlguipart";
	kl = new KLocale( catalogue, 0 );
	kl->setActiveCatalogue( catalogue );
	kl->setMainCatalogue( "sqlguipart" );

	resize( 600, 400 );

	QBoxLayout* box = new QBoxLayout( this, QBoxLayout::TopToBottom);
	te = new QTable(this);
	te->setNumRows(10);
	te->setNumCols(1);
	
	te->horizontalHeader()->setLabel( 0, kl->translate( i18n( "Stored Report-Queries" ) ) );
	// verticalHeader()->width()
	te->setColumnWidth( 0, this->width() - 50 );
	
	box->addWidget( te );
	
	// TODO: i18n und kl->translate()...
	
	QPushButton * okay = new QPushButton( this );
	
	okay->setText( kl->translate( i18n( "Okay" ) ) );
	
	box->addWidget( okay );
	
	connect( okay, SIGNAL( clicked() ), this, SLOT( slotChangeQueries() ) );
	connect( okay, SIGNAL( clicked() ), this, SLOT( accept() ) );
	
}

reportEditor::~reportEditor(){
// empty
}

void reportEditor::slotChangeQueries(){
	
	//std::cout << "0,0" << te->text(0,0).latin1() << endl;
	
	emit( report1Changed( te->text(0,0) ) );
	emit( report2Changed( te->text(1,0) ) );
	emit( report3Changed( te->text(2,0) ) );
	emit( report4Changed( te->text(3,0) ) );
	emit( report5Changed( te->text(4,0) ) );
	emit( report6Changed( te->text(5,0) ) );
	emit( report7Changed( te->text(6,0) ) );
	emit( report8Changed( te->text(7,0) ) );
	emit( report9Changed( te->text(8,0) ) );
	emit( report10Changed( te->text(9,0) ) );
}

void reportEditor::slotSetReport1( QString q ){
	report1 = q;
	te->setText( 0,0,q );
	//te->adjustColumn(0);
}
void reportEditor::slotSetReport2( QString q ){
	report2 = q;
	te->setText( 1,0,q );
	//te->adjustColumn(0);
}
void reportEditor::slotSetReport3( QString q ){
	report3 = q;
	te->setText( 2,0,q );
	//te->adjustColumn(0);
}
void reportEditor::slotSetReport4( QString q ){
	report4 = q;
	te->setText( 3,0,q );
	//te->adjustColumn(0);
}
void reportEditor::slotSetReport5( QString q ){
	report5 = q;
	te->setText( 4,0,q );
	//te->adjustColumn(0);
}
void reportEditor::slotSetReport6( QString q ){
	report6 = q;
	te->setText( 5,0,q );
	//te->adjustColumn(0);
}
void reportEditor::slotSetReport7( QString q ){
	report7 = q;
	te->setText( 6,0,q );
	//te->adjustColumn(0);
}
void reportEditor::slotSetReport8( QString q ){
	report8 = q;
	te->setText( 7,0,q );
	//te->adjustColumn(0);
}
void reportEditor::slotSetReport9( QString q ){
	report9 = q;
	te->setText( 8,0,q );
	//te->adjustColumn(0);
}
void reportEditor::slotSetReport10( QString q ){
	report10 = q;
	te->setText( 9,0,q );
	//te->adjustColumn(0);
}



