/***************************************************************************
                          sqlguiview.cpp  -  description
                             -------------------
    begin                : Sat Apr 14 18:28:06 CEST 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qprinter.h>
#include <qpainter.h>
#include <qapplication.h>

#include <qcombobox.h>
#include <qheader.h>
#include <qlistview.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>
#include <qtable.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qmessagebox.h>

#include <qprogressdialog.h>

#include <kapplication.h>
#include <klocale.h>

#include <kmenubar.h>
#include <kstatusbar.h>
#include <kfiledialog.h>

// application specific includes
#include "sqlguiview.h"
#include "sqlguidoc.h"

//#include <sqlguimysql/sqlguidoc.h>
//#include <sqlguimysql/sqlguidoc_mysql.h>


#include "sqlgui_part.h"
#include "adddata.h"

//#include <exp_dialog.h>
#include <exportbox.h>
#include <export_formate.h>

#include <math.h>

#include <iostream>
#include <iomanip>

SqlGuiView::SqlGuiView(QWidget *parent, const char *name) : QWidget(parent, name)
{
	setBackgroundMode(PaletteBase);

	myParentWidget = parent;

	const QString catalogue = "sqlguipart";
	kl = new KLocale( catalogue, 0 );
	kl->setActiveCatalogue( catalogue );
	kl->setMainCatalogue( "sqlguipart" );


	KToolBar::BarPosition toolBarPos;

	lastActionDB    = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
	lastActionTab   = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
	lastActionPrim  = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");

	lastActionDB->setLatin1("");
	lastActionTab->setLatin1("");
	lastActionPrim->setLatin1("");

	if ( !name )
		setName( "DB_Fenster" );

	setFocusPolicy(QWidget::ClickFocus);

	setCaption( kl->translate( i18n( "Formular" )));

	// erster Aufruf setzt Breite auf 20:80:
	//  SqlGuiApp * myApp = (SqlGuiApp *) parentWidget();
	QWidget * myApp = (QWidget *) parentWidget();
	int breite = myApp->width();
	int hoehe  = myApp->height();

	int x=0;
	int x0=0;
	//  toolBarPos = myApp->toolBar()->barPos();
	int stat_h=0;
	//  int tool_h= myApp->toolBar()->height();
	//  int mul = 1;
	//  if(myApp->viewStatusBar->isChecked()){
	//     stat_h = myApp->statusBar()->height();
	//   }
	//   if( (toolBarPos == KToolBar::Right) || (toolBarPos == KToolBar::Left) ){
	//     mul = 0;
	//     if(myApp->viewToolBar->isChecked()) x = myApp->toolBar()->width();
	//   }
	//   if(myApp->viewToolBar->isChecked()){
	//     if( (toolBarPos == KToolBar::Top) || (toolBarPos == KToolBar::Bottom) ) mul = 2;
	//   }
	//   breite -= x;
	//   hoehe=hoehe - stat_h - mul*tool_h;
	hoehe=hoehe - stat_h;
	int hoehe_mitte = hoehe - 140;
	int breite_links = (int) floor( 0.2 * breite );
	int breite_rechts = breite - breite_links - 5;

	exportdata = 3;
	exportform = 0;

	//  Kasten = new QFrame( this, "Kasten" );
	Kasten = new QFrame( myParentWidget, "Kasten" );
	Kasten->setFrameShape( QFrame::StyledPanel );
	Kasten->setFrameShadow( QFrame::Raised );

	Line1 = new QSplitter( Kasten, "Line1" );

	QValueList<int> breitenangabe;
	breitenangabe.append(breite_links);
	breitenangabe.append(breite_rechts);

	Line1->setSizes( breitenangabe );
	DATABASES = new QListView( Line1, "DATABASES" );
	DATABASES->addColumn(  kl->translate( i18n( "Databases" ))) ;
	DATABASES->addColumn(  kl->translate( i18n( "Type"      )));
	DATABASES->addColumn(  kl->translate( i18n( "Pri"       )));
	DATABASES->addColumn(  kl->translate( i18n( "Extra"     )));
	DATABASES->setFrameShadow( QListView::Sunken );
	DATABASES->setSelectionMode( QListView::Single );
	DATABASES->setColumnWidthMode( 0, QListView::Maximum );
	DATABASES->setRootIsDecorated( true );
	QWhatsThis::add(  DATABASES,  kl->translate( i18n( "List of Databases" ))) ;

	ResultList = new QTable( Line1, "ResultList" );
	ResultList->setSizePolicy( QSizePolicy( QSizePolicy::Maximum, QSizePolicy::Maximum, false ) );
	ResultList->setSelectionMode( QTable::Single );
	QWhatsThis::add(  ResultList,  kl->translate( i18n( "Result-List" )));


	sqlEdit = new QMultiLineEdit( Kasten, "sqlEdit" );
	QWhatsThis::add(  sqlEdit,  kl->translate( i18n( "SQL-Editor: Enter your SQL-statement, select the database (from the upper-left list), which should be affected, and click on OK to submit your query to the server." )));

	sqlEditClear = new QPushButton( Kasten, "sqlEditClear" );
	sqlEditClear->setText( kl->translate( i18n( "Clear" )));

	sqlSubmit = new QPushButton( Kasten, "sqlSubmit" );
	sqlSubmit->setText(  kl->translate( i18n( "OK" )));

	sqlHistory = new QComboBox( FALSE, Kasten, "sqlHistory" );
	QWhatsThis::add(  sqlHistory, kl->translate( i18n( "SQL-History: your last SQL-statements are listed here." )));

	// KFileDialog suxx!
	//  whatfile2 = new KFileDialog(QString::null, "*", myParentWidget, "Export-File", FALSE);
	whatfile2 = new QFileDialog(myParentWidget, "Export-File", FALSE);
	whatfile2->setMode(QFileDialog::AnyFile);
	whatfile2->hide();

	QString * tempStr=new QString("");

	// Default: slow, but not memory-consuming
	fast = false;

	maxNumColsResultlist = 0;
	maxNumRowsResultlist = 0;

	doc = NULL;

	menu = new QPopupMenu(this);

	QString * countrows     = new QString( kl->translate( i18n("Count Table-Rows")));
	QString * status        = new QString( kl->translate( i18n("Server-Status")));
	QString * newbase       = new QString( kl->translate( i18n("Create Base")));
	QString * newtable      = new QString( kl->translate( i18n("Create Table")));
	QString * delbase       = new QString( kl->translate( i18n("Delete Base")));
	QString * deltable      = new QString( kl->translate( i18n("Delete Table")));
	QString * checktable    = new QString( kl->translate( i18n("Check/Analyse Table")));
	QString * optimizetable = new QString( kl->translate( i18n("Optimize/Vacuum Table")));
	QString * repairtable   = new QString( kl->translate( i18n("Repair/Reindex Table")));
	QString * edittable     = new QString( kl->translate( i18n("Edit Table")));
	QString * addtabledata  = new QString( kl->translate( i18n("Add Table-Data")));
	QString * exportdb      = new QString( kl->translate( i18n("Export")));


	menu->insertItem( *status, this, SLOT( slotServerStatus() ) );
	menu->insertItem( *countrows, this, SLOT( slotTableRowCount() ) );
	menu->insertSeparator();
	menu->insertItem( *newbase, this, SLOT( slotCreateDB() ) );
	menu->insertItem( *delbase, this, SLOT( slotDeleteBase() ) );
	menu->insertSeparator();
	menu->insertItem( *newtable, this, SLOT( slotCreateTable() )  );
	menu->insertItem( *deltable, this, SLOT( slotDeleteTable() ) );
	menu->insertItem( *edittable, this, SLOT( slotToDo( ) ));
	menu->insertSeparator();
	menu->insertItem( *checktable, this, SLOT( slotCheckTable() ) );
	menu->insertItem( *optimizetable, this, SLOT( slotOptimizeTable() ) );
	menu->insertItem( *repairtable, this, SLOT( slotRepairTable() ) );
	menu->insertSeparator();
	menu->insertItem( *addtabledata, this, SLOT( slotAddTableData() ) );
	menu->insertItem( *exportdb, this, SLOT( slotExport() ) );

	exportIndex=15;
	counterIndex=1;
	tcheckIndex=10;
	toptimizeIndex=11;
	trepairIndex=12;
	tcreateIndex=6;
	tdeleteIndex=7;
	teditIndex=8;
	dcreateIndex=3;
	ddeleteIndex=4;
	insertIndex=14;

	menu->setItemEnabled( menu->idAt(exportIndex), false );
	menu->setItemEnabled( menu->idAt(tcheckIndex), false );
	menu->setItemEnabled( menu->idAt(toptimizeIndex), false );
	menu->setItemEnabled( menu->idAt(trepairIndex), false );
	menu->setItemEnabled( menu->idAt(tdeleteIndex), false );
	menu->setItemEnabled( menu->idAt(teditIndex), false );
	menu->setItemEnabled( menu->idAt(tcreateIndex), false );
	menu->setItemEnabled( menu->idAt(ddeleteIndex), false );

	// signals and slots connections
	connect( sqlEditClear, SIGNAL( clicked() ), sqlEdit, SLOT( clear() ) );
	connect( sqlHistory, SIGNAL( activated(const QString&) ), sqlEdit, SLOT( setText(const QString&) ) );
	connect( sqlSubmit, SIGNAL( clicked() ) , this, SLOT( slotEditorQuery() ) );
	connect( sqlSubmit, SIGNAL( clicked() ) , this, SLOT( slotEditorAddHistory() ) );
	connect( DATABASES, SIGNAL( doubleClicked( QListViewItem* ) ) , this, SLOT( slotDoubleClickQuery( QListViewItem* ) ) );
	connect( DATABASES, SIGNAL( rightButtonPressed ( QListViewItem *, const QPoint &, int ) ), this, SLOT( slotDbMenu( QListViewItem *, const QPoint &, int )  ) );
	connect( ResultList, SIGNAL( valueChanged( int, int ) ) , this, SLOT( slotUpdateTable( int, int ) ) );
	connect( ResultList, SIGNAL( selectionChanged( ) ) , this, SLOT( slotSelectionChanged( ) ) );
	connect( ResultList, SIGNAL( pressed( int, int, int, const QPoint &) ) , this, SLOT( slotDbMenu( int, int, int, const QPoint &) ) );

	connect( whatfile2, SIGNAL(fileSelected( const QString & ) ), this, SLOT( slotConfirmOverwrite( const QString & ) ) );

	// KFileDialog suxx:
	//  connect( whatfile2, SIGNAL(okClicked() ), this, SLOT( slotWriteFile() ) );

	connect( this, SIGNAL( overwrite( const QString & ) ), this , SLOT(slotSelectExport( const QString & ) ) );
	connect( this, SIGNAL( donotoverwrite( const QString & ) ), this , SLOT( slotExportDlg2() ) );


	Kasten->show();

	adder = new AddData( myParentWidget, "Add Data", true, 0, 0);
	connect( adder, SIGNAL( insertRequest( QString*, QString* )), this, SIGNAL(doQuery(QString*, QString*) )  );
	//	connect( this, SIGNAL( gotQueryDone() ), adder, SLOT( accept() ) );
	connect( this, SIGNAL( gotQueryDone() ), adder, SLOT( slotQuerySucceded() ) );
	connect( this, SIGNAL( gotQueryNotDone() ), adder, SLOT( slotQueryFailed() ) );
	
	
	
	
}

SqlGuiView::~SqlGuiView()
{
}

void SqlGuiView::slotSelectionChanged()
{
	bool on = false;
	if( ResultList->currentSelection() >= 0){
		on = true;
		QTableSelection s = ResultList->selection(0);
		if( (s.topRow() == s.bottomRow()) && (s.leftCol() == s.rightCol() )  ){
			on=false;
		}
	}
	menu->setItemEnabled( menu->idAt( exportIndex ), on );
	menu->updateItem( menu->idAt( exportIndex) );
	emit( selectionChanged( on ) );
}

void SqlGuiView::setDocument( SqlGuiDoc* d ){
	doc = d;
}

SqlGuiDoc *SqlGuiView::getDocument() const
{
	// std::cout << "...enterering SqlGuiView::getDocument" << endl;
	return ((SqlGuiPart*)myParentWidget)->getDocument();
}

void SqlGuiView::print(QPrinter *pPrinter)
{
	QPainter printpainter;
	printpainter.begin(pPrinter);

	// TODO: add your printing code here

	printpainter.end();
}

void SqlGuiView::resizeEvent( QResizeEvent * e){

	KToolBar::BarPosition toolBarPos;

	int men_h = 0;
	int stat_h = 0;
	int x=0;
	int x0=0;

	int breite = e->size().width();
	int hoehe  = e->size().height();

	int tool_h = 0;
	int mul = 0;

	breite -= x;

	//  hoehe = hoehe - stat_h - mul*tool_h - men_h;
	int hoehe_mitte = hoehe - 140;

	int breite_links = (int) floor( 0.2 * breite );
	int breite_rechts = breite - breite_links - 5;

	Kasten->resize( breite, hoehe );
	sqlEdit->setGeometry( QRect( 0, hoehe_mitte, breite - 80 , 110 ) );
	sqlEditClear->setGeometry( QRect( breite - 80, hoehe_mitte, 80, 40 ) );
	sqlSubmit->setGeometry( QRect( breite - 80, hoehe_mitte + 40, 80, 70 ) );
	sqlHistory->setGeometry( QRect( 0, hoehe_mitte + 110, breite, 30 ) );
	Line1->setGeometry( QRect( 0, 0, breite, hoehe_mitte ) );
}

QString *SqlGuiView::selectedDB()
{
	QListViewItem * item=NULL;
	QString * data =  new QString;

	item = DATABASES->selectedItem();

	if( item ){
		int d = item->depth();
		while(d!=0){
			item=item->parent();
			d=item->depth();
		}
		data->setLatin1( item->text(0).latin1() );
	}

	if(data) return data;
	else return NULL;
}

QString *SqlGuiView::selectedTable()
{
	QListViewItem * item=NULL;
	QString * data =  new QString;
	//  // std::cout << "Start..." << endl;

	item = DATABASES->selectedItem();

	if( item ){
		int d = item->depth();
		if (d>=1){
			while(d>1){
				item=item->parent();
				d=item->depth();
			}
			data->setLatin1( item->text(0).latin1() );
		}
	}
	//  // std::cout << "Searched Tables..." << endl;

	if(data) return data;
	else return NULL;
}

void SqlGuiView::slotSetFast( bool b ){

	// We are in fast-mode and switch to slow-mode:
	if ( fast && (!b)){

		int tot = 0;
		int prg = 0;

		QApplication::setOverrideCursor( Qt::waitCursor );

		// we need to clean up all unused table-data:
		int rlx = ResultList->numCols();
		int rly = ResultList->numRows();

		// calculating how much to remove:
		if ( rlx < maxNumColsResultlist ){
			if ( rly < maxNumRowsResultlist ){
				tot = rly*(maxNumColsResultlist-rlx) + (maxNumRowsResultlist-rly)*maxNumColsResultlist;
			}
		}
		if ( (rlx==maxNumColsResultlist) && (rly<maxNumRowsResultlist) ){
			tot = (maxNumRowsResultlist-rly)*rlx;
		}
		if ( (rly==maxNumRowsResultlist) && (rlx<maxNumColsResultlist) ){
			tot = (maxNumColsResultlist-rlx)*rly;
		}

		ResultList->setNumCols( maxNumColsResultlist );
		ResultList->setNumRows( maxNumRowsResultlist );

		// Say, what we are doing:
		QProgressDialog progress( kl->translate( i18n("Freeing some memory, please wait...")) ,
		                          "(ToDo: remove this button)", tot, myParentWidget, "progress", TRUE );

		progress.setCancelButton(NULL);

		// Now removing cells:
		if ( rlx < maxNumColsResultlist ){
			if ( rly < maxNumRowsResultlist ){
				for (int r = 0; r < rly; r++){
					for(int s = rlx; s< maxNumColsResultlist; s++){
						ResultList->clearCell( r,s );
						progress.setProgress(++prg);
					}
				}
				for (int r = rly; r < maxNumRowsResultlist; r++){
					for (int s = 0; s < maxNumColsResultlist; s++){
						ResultList->clearCell( r,s );
						progress.setProgress(++prg);
					}
				}
			}
		}
		if ( (rlx==maxNumColsResultlist) && (rly<maxNumRowsResultlist) ){
			for (int r=rly; r<maxNumRowsResultlist; r++){
				for(int s=0; s<rlx; s++){
					ResultList->clearCell( r,s );
					progress.setProgress(++prg);
				}
			}
		}
		if ( (rly==maxNumRowsResultlist) && (rlx<maxNumColsResultlist) ){
			for (int r=0; r<rly; r++){
				for(int s=rlx; s<maxNumColsResultlist; s++){
					ResultList->clearCell( r,s );
					progress.setProgress(++prg);
				}
			}
		}
		progress.setProgress(tot);
		ResultList->setNumCols( rlx );
		ResultList->setNumRows( rly );
		QApplication::restoreOverrideCursor();
	}  // end if (fast && !b)

	// We are in slow-mode and switch to fast-mode:
	if( (!fast) && b ){
		// We set maximum (maxNumRowsResultlist, maxNumColsResultlist) to the size of the actual table:
		maxNumColsResultlist = ResultList->numCols();
		maxNumRowsResultlist = ResultList->numRows();
	}
	fast = b;
}

void SqlGuiView::slotDbMenu( QListViewItem * item, const QPoint & pos, int num)
{
	if(item){
		if(item->depth()==1){ // Klick auf Tabelle:
			menu->setItemEnabled( menu->idAt(counterIndex), true );
			menu->setItemEnabled( menu->idAt(tcheckIndex), true );
			menu->setItemEnabled( menu->idAt(toptimizeIndex), true );
			menu->setItemEnabled( menu->idAt(trepairIndex), true );
			menu->setItemEnabled( menu->idAt(tdeleteIndex), true );
			menu->setItemEnabled( menu->idAt(teditIndex), false ); // Implementieren...
			menu->setItemEnabled( menu->idAt(tcreateIndex), true );
			menu->setItemEnabled( menu->idAt(ddeleteIndex), false );
			menu->setItemEnabled( menu->idAt(insertIndex), true );

		}
		else{ // Klick auf Type, etc...
			menu->setItemEnabled( menu->idAt(counterIndex), true );
			menu->setItemEnabled( menu->idAt(tdeleteIndex), false );
			menu->setItemEnabled( menu->idAt(teditIndex), false ); // Implementieren...
			menu->setItemEnabled( menu->idAt(tcreateIndex), true );
			menu->setItemEnabled( menu->idAt(ddeleteIndex), false );
			menu->setItemEnabled( menu->idAt(insertIndex), true );

		}
		if(item->depth()==0){ // Klick auf DB
			menu->setItemEnabled( menu->idAt(tcheckIndex), false );
			menu->setItemEnabled( menu->idAt(toptimizeIndex), false );
			menu->setItemEnabled( menu->idAt(trepairIndex), false );
			menu->setItemEnabled( menu->idAt(tdeleteIndex), false );
			menu->setItemEnabled( menu->idAt(teditIndex), false ); // Implementieren...
			menu->setItemEnabled( menu->idAt(tcreateIndex), true );
			menu->setItemEnabled( menu->idAt(ddeleteIndex), true );
			menu->setItemEnabled( menu->idAt(insertIndex), false );
			menu->setItemEnabled( menu->idAt(counterIndex), false );

		}
	} else {
		menu->setItemEnabled( menu->idAt(tcheckIndex), false );
		menu->setItemEnabled( menu->idAt(toptimizeIndex), false );
		menu->setItemEnabled( menu->idAt(trepairIndex), false );
		menu->setItemEnabled( menu->idAt(tdeleteIndex), false );
		menu->setItemEnabled( menu->idAt(teditIndex), false ); // Implementieren...
		menu->setItemEnabled( menu->idAt(tcreateIndex), false );
		menu->setItemEnabled( menu->idAt(ddeleteIndex), false );
		menu->setItemEnabled( menu->idAt(insertIndex), false );
		menu->setItemEnabled( menu->idAt(counterIndex), false );

	}
	menu->exec( pos, 0);
}

void SqlGuiView::slotDbMenu( int row, int col, int button, const QPoint & mousePos)
{
	if(button==2){
		menu->setItemEnabled( menu->idAt(tcheckIndex), false );
		menu->setItemEnabled( menu->idAt(toptimizeIndex), false );
		menu->setItemEnabled( menu->idAt(trepairIndex), false );
		menu->setItemEnabled( menu->idAt(counterIndex), false );
		menu->setItemEnabled( menu->idAt(ddeleteIndex), false );
		menu->setItemEnabled( menu->idAt(insertIndex), false );
		menu->setItemEnabled( menu->idAt(tcreateIndex), false );

		QValueList<int> s = Line1->sizes();
		QValueList<int>::Iterator it = s.begin();

		// Coordinates in QT suxx!!!
		// Click on QListViewItem reurns absolute position of mouse, click on QTable relative mouseposition to parent.
		// And mapToGlobal does not return the correct coordinates. So we have to calculate this f****** b******* manually!
		// ... no exact position, just aproximating...
		QPoint *pos = new QPoint( mousePos.x()+ *it + 60, mousePos.y() + 26 );
		menu->exec( QWidget::mapToGlobal( *pos ), 0);
	}
}


void SqlGuiView::slotToDo(){
	QMessageBox::information( myParentWidget, kl->translate( i18n( "Ooops...")),  kl->translate( i18n( "Not implemented yet")));
}

void SqlGuiView::message(QString * msg = NULL){
	if(msg!=NULL) QMessageBox::information( myParentWidget, kl->translate( i18n( "Ooops...")), msg->latin1() );
}

void SqlGuiView::slotCreateDB()
{
	emit( createDb() );
}

void SqlGuiView::slotTableRowCount(){
	emit( countRowRequested( selectedDB(), selectedTable() ) );
}

void SqlGuiView::slotServerStatus(){
	emit( serverStatusRequested() );
}

void SqlGuiView::slotAddTableData(){

	int c = 0;
	//AddData * adder = new AddData( myParentWidget, "Add Data", true, 0, c);
	QListViewItem * item=NULL;
	QString * colname =  new QString;
	QString * tabname =  new QString;

	adder->setDb( selectedDB() );

	item = DATABASES->selectedItem();
	if( item ){
		int d = item->depth();
		if (d>=1){
			while(d>1){
				item=item->parent();
				d=item->depth();
			}
			tabname->setLatin1( item->text(0).latin1() );
			adder->setTab( tabname );
		}
		if (d < 1){
			QString* msg = new QString( kl->translate( i18n("Please select a table, not a database")));
			message( msg );
			return;
		}
		// Okay: we have the table, now we get all its columns:
		item = item->firstChild();
		while(item){
			colname->setLatin1( item->text(0).latin1() );
			bool p = ( item->text(2).compare( "Y" ) == 0 ) ? (true) : (false);
			bool a = ( item->text(3).compare( "auto_increment" ) == 0 ) ? (true) : (false);
			//			// std::cout << "Spalte " << colname->latin1() << endl;
			//			// std::cout << "1 " << item->text(1).latin1() << endl;
			//			// std::cout << "2 " << item->text(2).latin1() << endl;
			//			// std::cout << "3 " << item->text(3).latin1() << endl;
			adder->addCol( colname, p, a );
			item = item->nextSibling();
		}
	}
	// connect( adder, SIGNAL( insertRequest( QString*, QString* )), this, SIGNAL(doQuery(QString*, QString*) )  );
	// //	connect( this, SIGNAL( gotQueryDone() ), adder, SLOT( accept() ) );
	// connect( this, SIGNAL( gotQueryDone() ), adder, SLOT( slotQuerySucceded() ) );
	// connect( this, SIGNAL( gotQueryNotDone() ), adder, SLOT( slotQueryFailed() ) );
	adder->show();

}

void SqlGuiView::slotQueryDone(){
	emit( gotQueryDone() );
}

void SqlGuiView::slotQueryUnDone(){
	emit( gotQueryNotDone() );
}

void SqlGuiView::deleteBase()
{

	//  switch( QMessageBox::warning( this, "SqlGui",i18n("You are going to delete a database and all it's contents!\nIt will be impossible to restore it!\nYou have been warned...\n"),i18n("Delete"), i18n("Cancel"), 0, 0, 1 ) )
	switch( QMessageBox::warning( myParentWidget, "SqlGui", kl->translate( i18n("You are going to delete a database and all it's contents!\nIt will be impossible to restore it!\nYou have been warned...\n")),
	                              kl->translate( i18n("Delete")), kl->translate( i18n("Cancel")), 0, 0, 1 ) )
	{
	case 0:
		{
			//	emit( deleteDb( this->selectedDB() ) );
			emit( deleteDb( selectedDB() ) );
			break;
		}
	case 1:
		{
			break;
		}
	}
}


void SqlGuiView::slotCheckTable()
{
	//  emit( checkTable(this->selectedDB(), this->selectedTable() ));
	emit( checkTable(selectedDB(), selectedTable() ));
}

void SqlGuiView::slotOptimizeTable()
{
	//  emit( optimizeTable(this->selectedDB(), this->selectedTable() ));
	emit( optimizeTable(selectedDB(), selectedTable() ));
}

void SqlGuiView::slotRepairTable()
{
	//  emit( repairTable(this->selectedDB(), this->selectedTable() ));
	emit( repairTable(selectedDB(), selectedTable() ));
}

void SqlGuiView::slotCreateTable()
{
	emit( createTable() );
}

void SqlGuiView::deleteTable()
{
	// switch( QMessageBox::warning( this, "SqlGui",i18n("You are going to delete a table and all it's contents!\nIt will be impossible to restore it!\nYou have been warned...\n"),i18n("Delete"), i18n("Cancel"), 0, 0, 1 ) )
	switch( QMessageBox::warning( myParentWidget, "SqlGui", kl->translate( i18n("You are going to delete a table and all it's contents!\nIt will be impossible to restore it!\nYou have been warned...\n")),
	                              kl->translate( i18n("Delete")), kl->translate( i18n("Cancel")), 0, 0, 1 ) )
	{
	case 0:
		{
			//	emit( deleteTable( this->selectedDB(), this->selectedTable() ) );
			emit( deleteTable( selectedDB(), selectedTable() ) );
			break;
		}
	case 1:
		{
			break;
		}
	}
}
void SqlGuiView::slotDeleteTable()
{
	//  this->deleteTable();
	deleteTable();
}
void SqlGuiView::slotDeleteBase()
{
	//  this->deleteBase();
	deleteBase();
}

void SqlGuiView::slotUpdateTable(int row, int col)
{
	// std::cout << "Okay, updating the table..." << endl;
	QString * sql = new QString("Update ");
	sql->append( *lastActionTab );
	sql->append( " set " );
	sql->append( ResultList->horizontalHeader()->label(col) );
	sql->append(" = '");
	sql->append( ResultList->text(row, col) );
	sql->append("' where ");
	sql->append( *lastActionPrim );
	sql->append(" LIKE '");
	// Welcher Wert steht in der Spalte mit dem Primary-Key?
	int c = ResultList->numCols();
	int index_col = -1;
	int i = 0;
	for(i = 0; i < c; i++)
	{
		//// std::cout << "I: " << i << " PrimKey: " << lastActionPrim->latin1() << " Head(i): " <<ResultList->horizontalHeader()->label(i).latin1();
		if ( lastActionPrim->compare( ResultList->horizontalHeader()->label(i) ) == 0 )
		{
			index_col = i;
			//// std::cout << " equal " << endl;
		}
		else
		{
			//// std::cout << " not equal " << endl;
		}
	}
	//// std::cout << "Index-Column: " << index_col << endl;
	if(index_col > -1)	sql->append( ResultList->text(row, index_col) );
	sql->append("'");
	// std::cout << "Okay, sending SQL-statement to database " << lastActionDB->latin1() << endl;
	// std::cout << sql->latin1() << endl;
	emit doQuery( lastActionDB, sql );
}

void SqlGuiView::slotUpdateLastAction(QString* db, QString* tab, QString* prim)
{
	lastActionDB->setLatin1(  db->latin1()   );
	lastActionTab->setLatin1(  tab->latin1()  );
	lastActionPrim->setLatin1(  prim->latin1() );
	// std::cout << "Last Action on:" << endl;
	// std::cout << "  DB  : " << db->latin1() << endl;
	// std::cout << "  Tab : " << tab->latin1() << endl;
	// std::cout << "  Prim: " << prim->latin1() << endl;
}

void SqlGuiView::slotUpdateResultList()
{
	int x = ResultList->numCols();
	int y = ResultList->numRows();
	//  // std::cout << "x = " << x << " y = " << y << endl;

	int i=0;
	int j=0;
	int xx=0;
	int yy=0;


	QApplication::setOverrideCursor( Qt::waitCursor );

	// Das hier dauert mir zu lange:
	//
	//  if((x>0)&(y>0)){
	//    for(i=0; i<x ; i++)
	//      for(j=0; j<y; j++){
	//	ResultList->clearCell(j,i);
	//      }
	//  }
	//

	// Das Objekt einfach zu DELETEn ist schneller, krashed aber beim dritten mal dieses Programm (dafr gehrt mindestens ein Troll verprgelt)...

	//  SqlGuiDoc * doc = this->getDocument();
	//  SqlGuiDoc * doc = getDocument();

	//	// std::cout << "got doc" << endl;

	//	// std::cout << "trying to get FirstResult" << endl;
	row_t * result = doc->getFirstRes();
	//	// std::cout << "got first result: Pointer " << result << endl;


	field_t * col = NULL;
	if(result) col = result->feld;
	row_t   * row = result;
	xx=0;
	while(col){
		xx++;
		col=col->next;
	}
	yy=0;
	while(row){
		yy++;
		row=row->next;
	}
	//  // std::cout << "Rows: " << yy << " Cols: " << xx << endl;

	// Eigentlich sollte es so sein, da man in der QTable einfach die Breitze und Hhe setzen kann,
	// und dann QT selbstndig den Speicher wieder freigibt. Allerdings scheint mir das nicht ganz koscher.
	// Verwende ich nur 'setNumCols/Rows' und 'setText', dann passiert fogendes:
	// Wenn ich 5 - 6 mal nacheinander eineige groe Tabellen (5000 Zeilen a 50 Spalten, voll mit text und varchar)
	// aufrufe, beginnt mein Rechner sehr schnell zu swappen, und irgendwann wird SqlGui gekilled, weil es zuviel Speicher braucht.

	// Deswegen entferne ich hier alle berflssigen Zeilen/Spalten von Hand. Die Zeilen, die bereits vorhanden sind,
	// knnen natrlich wiederverwendet werden, deswegen wird hier etwas umstndlich abgezhlt.

	// Das ist dann zwar ein ganzes Stck langsamer, als nur 'setNumCols/Rows' und 'setText', dafr fllt es aber den Speicher nicht auf.

	// Alle nicht mehr bentigten Zeilen/Spalten wegwerfen:
	// x  alte breite   y  alte hoehe
	// xx neue breite   yy neue hoehe
	//
	// Vier Flle sind zu beachten:
	//
	//           x       xx
	//  ------------------
	// |         |        |
	// |         |        |
	// |  bleibt | neu    |
	// |         |        |
	//  ------------------  y
	// |         |        |
	// |  neu    | neu    |
	// |         |        |
	// |         |        |
	//  ------------------  yy
	//
	//
	//
	//           xx       x
	//  ------------------
	// |         |        |
	// |  bleibt | weg    |
	// |         |        |
	// |         |        |
	//  ------------------  y
	// |         |        |
	// |  neu    |        |
	// |         |        |
	// |         |        |
	//  ------------------  yy
	//
	//
	//
	//           xx       x
	//  ------------------
	// |         |        |
	// |  bleibt | weg    |
	// |         |        |
	// |         |        |
	//  ------------------  yy
	// |         |        |
	// |  weg    | weg    |
	// |         |        |
	// |         |        |
	//  ------------------  y
	//
	//
	//
	//           x        xx
	//  ------------------
	// |         |        |
	// |  bleibt | neu    |
	// |         |        |
	// |         |        |
	//  ------------------  yy
	// |         |        |
	// |  weg    |        |
	// |         |        |
	// |         |        |
	//  ------------------  y
	//
	//
	
	//
	// Im Fastmode wird allerdings anders vorgegangen:
	// Es werden immer mehr Zeilen / Spalten belegt, soda man letztendlich immer mehr Speicher bentigt.
	// Vorteil: der Aufbau sollte schneller werden
	// Nachteil: belegt mehr Speicher (evtl. bis zum Absturz)
	//
	
	int tot = 0;
	if ( ! fast ){
		if (xx < x){
			if ( y > yy ){
				tot = (y-yy)*x + yy*(x-xx);
			}
			if (y < yy ){
				tot = (x-xx) * (yy-y);
			}
		}
		if ( ( xx > x ) && (y > yy) ){
			tot = (y-yy) * x;
		}
	} else {
		
		// inzw. unntig:
		
		//if (xx > maxNumColsResultlist ){
		//	if (yy > maxNumRowsResultlist ){
		//		tot = ( xx - maxNumColsResultlist) * yy + ( yy - maxNumRowsResultlist) * maxNumColsResultlist;
		//	} else {
		//		tot = ( xx - maxNumColsResultlist) * maxNumRowsResultlist;
		//	}
		//} else {
		//	if (yy > maxNumRowsResultlist){
		//		tot = ( yy - maxNumRowsResultlist ) *  maxNumColsResultlist;
		//	}
		//}

	}

	int maxY = ( yy > y ) ? yy : y;
	int maxX = ( xx > x ) ? xx : x;

	QString* prgmsg = new QString("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
	if (fast){
		prgmsg->setLatin1( kl->translate( i18n("Consuming more memory, please wait...")));
	} else {
		prgmsg->setLatin1( kl->translate( i18n("Freeing some memory, please wait...")));
	}

	QProgressDialog progress( prgmsg->latin1() , "(ToDo: remove this button)", tot, myParentWidget, "progress", TRUE );
	progress.setCancelButton(NULL);
	int prg = 0;

	// Slow: Delete all unnecessary cells:
	if( ! fast ){
		if( xx < x ){
			for (i=xx; i<x; i++)
			for(j=0; j<y; j++) {ResultList->clearCell(j,i);progress.setProgress(++prg);}

			if ( y > yy ){
				for (i=0; i<xx; i++)
				for(j=yy; j<y; j++) {ResultList->clearCell(j,i);progress.setProgress(++prg);}
			}
		}
		if( xx > x){
			if( y > yy ) {
				for (i=0; i<x; i++)
				for(j=yy; j<y; j++) {ResultList->clearCell(j,i);progress.setProgress(++prg);}

			}
		}
	}

	// Breite setzen:
	if (fast){
		if (maxX > maxNumColsResultlist ){ ResultList->setNumCols( maxX );} else { ResultList->setNumCols( maxNumColsResultlist );}
		if (maxY > maxNumRowsResultlist ){ ResultList->setNumRows( maxY );} else { ResultList->setNumRows( maxNumRowsResultlist );}
	}

	///
	// unnecessary: no need to create QTableItem; QTable does this automagically now.
	//
	// Fast: expand table as much as possible (ie.: never delete cells -> consuming very much memory):
	// if ( fast ){
		// if ( xx > maxNumColsResultlist ){
			// //int maxy = (yy>y) ? yy : y;
			// int maxy = maxNumRowsResultlist;
			// for( int r=0; r<maxy; r++){
				// for( int s=maxNumColsResultlist; s<xx; s++){
					// QTableItem * Zelle = new QTableItem(ResultList, QTableItem::OnTyping, QString::QString("") );
					// ResultList->setItem(r,s,Zelle);
					// progress.setProgress(++prg);
				// }
			// }
			// //if (yy>y) {
			// if (yy>maxNumRowsResultlist) {
				// //for( int r=y; r<yy; r++ ){
				// for( int r=maxNumRowsResultlist; r<yy; r++ ){
					// //for( int s=0; s<x; s++){
					// for( int s=0; s<xx; s++){
						// QTableItem * Zelle = new QTableItem(ResultList, QTableItem::OnTyping, QString::QString("") );
						// ResultList->setItem(r,s,Zelle);
						// progress.setProgress(++prg);
					// }
				// }
			// }
		// } else {
			// if ( yy > maxNumRowsResultlist ){
				// for( int r=y; r<yy; r++ ){
					// for( int s=0; s<x; s++){
						// QTableItem * Zelle = new QTableItem(ResultList, QTableItem::OnTyping, QString::QString("") );
						// ResultList->setItem(r,s,Zelle);
						// progress.setProgress(++prg);
					// }
				// }
			// }
		// }
	// }

//	maxNumRowsResultlist = ( maxY > maxNumRowsResultlist) ? maxY : maxNumRowsResultlist;
//	maxNumColsResultlist = ( maxX > maxNumColsResultlist) ? maxX : maxNumColsResultlist;

	// Benutzung der Methoden removeRow/removeColumn dauert noch lnger...:(
	//if ( xx < x ){
	//     if ( y < yy ){
	//         for (i=xx; i<x; i++){
	//              ResultList->removeColumn(i);
	//              progress.setProgress(++prg);
	//         }
	//     }
	//     if ( y > yy ){
	//         for (i=xx; i<x; i++){
	//              ResultList->removeColumn(i);
	//              progress.setProgress(++prg);
	//         }
	//         for (i=yy; i<y; i++){
	//              ResultList->removeRow(i);
	//              progress.setProgress(++prg);
	//         }
	//     }
	//
	//}
	//if (( xx > x) && (y>yy)){
	//     for(i=yy;i<y;i++){
	//         ResultList->removeRow(i);
	//         progress.setProgress(++prg);
	//     }
	//}

	progress.setProgress(tot);

	// Breite setzen:
	ResultList->setNumCols(xx);
	ResultList->setNumRows(yy);

	QString * msg = new QString;
	msg->setNum(yy);
	msg->prepend("Connected (last query: ");
	msg->append(" rows)");

	emit( statusBarRequest( *msg ) );

	QApplication::restoreOverrideCursor();
	if (yy==0)
	{
		emit gotResult();
		return;
	}
	QApplication::setOverrideCursor( Qt::waitCursor );

	i=0;
	j=0;

	// Rest einfgen:
	while( result ){
		field_t * column = result->feld;
		i=0;
		while( column ){
			QString Wert = QString::fromLocal8Bit( column->value );
			//QString *Wert = new QString( column->value );
			
			// folgendes ist obsolet geworden, da die QTable inzwischen ordentlich funktioniert:
			//	if ( ! fast ){
			//		// Ist i > x mssen wir das TableItem neu erzeugen, ebenso wenn j > y ist.
			//		if( (i>x) || (j>y) ){
			//			QTableItem * Zelle = new QTableItem(ResultList, QTableItem::OnTyping, Wert);
			//			ResultList->setItem(j,i,Zelle);
			//		} else {
			//			ResultList->setText( j,i,Wert );
			//			ResultList->updateCell(j,i);
			//		}
			//	} else {
			//	//	ResultList->setText( j,i,Wert );
			//	//	ResultList->updateCell(j,i);
			//		if( (i>maxNumColsResultlist) || (j>maxNumRowsResultlist) ){
			//			QTableItem * Zelle = new QTableItem(ResultList, QTableItem::OnTyping, Wert);
			//			ResultList->setItem(j,i,Zelle);
			//		} else {
			//			ResultList->setText( j,i,Wert );
			//			ResultList->updateCell(j,i);
			//		}
			//	}
			
			/// wir knnen direkt den Text setzen, ohne das QTableItem neu erzeugen zu mssen.
			ResultList->setText( j,i,Wert );
			ResultList->updateCell(j,i);
			
			column=column->next;
			i++;
		}
		j++;
		result=result->next;
	}

	
	maxNumRowsResultlist = ( maxY > maxNumRowsResultlist) ? maxY : maxNumRowsResultlist;
	maxNumColsResultlist = ( maxX > maxNumColsResultlist) ? maxX : maxNumColsResultlist;
	
	//  QApplication::restoreOverrideCursor();
	// Kopf schreiben:
	QHeader * kopf = ResultList->horizontalHeader();
	colu = doc->resultCols();
	int v=0;
	while(colu){
		QString * k_name = new QString( colu->name );
		kopf->setLabel(v, *k_name );
		delete k_name;
		ResultList->adjustColumn(v);
		v++;
		colu=colu->next;
	}
	QApplication::restoreOverrideCursor();
	// std::cout << "Sending Clear-Memory-Request..." << endl;
	emit( gotResult() );
	// std::cout << "ResultList should be updated now..." << endl;
}

void SqlGuiView::slotEditorAddHistory()
{
	QString s;
	if(! sqlEdit->text().isEmpty() ){
		s.setLatin1( sqlEdit->text().latin1() );
		sqlHistory->insertItem( s,0);
	}

}

void SqlGuiView::slotEditorQuery()
{
	QString * b = new QString;
	QString * s = new QString;
	QListViewItem * item;


	item = DATABASES->selectedItem();
	if( item ){
		int d = item->depth();
		while(d!=0){
			item=item->parent();
			d=item->depth();
		}
		b->setLatin1( item->text(0).latin1() );
	}
	if( sqlEdit->text() )s->setLatin1( sqlEdit->text().latin1() );
	emit( doQuery( b, s ) );
}

void SqlGuiView::slotDoubleClickQuery( QListViewItem * item )
{
	QString * b = new QString;
	QString * t = new QString;
	QString s;

	s.setLatin1("Select * From ");

	if( item ){
		int d = item->depth();
		if(d!=1) return;
		item->setOpen(! item->isOpen() );
		t->setLatin1( item->text(0).latin1() );
		s = s.append( *t );
		item=item->parent();
		b->setLatin1( item->text(0).latin1() );
	}

	// std::cout << "Got DoubleClick on " << t->latin1()  << endl;

	emit( doQuery( b, &s ) );
}

void SqlGuiView::slotUpdateMainView(){

	// std::cout 	<< "entering 'slotUpdateMainView'" << endl;
	base_t * hilf = NULL;
	//  SqlGuiDoc * doc = this->getDocument();

	//  // std::cout << "...trying to get docunment..." << endl;
	//  SqlGuiDoc * doc = getDocument();
	//  // std::cout << "got document..." << endl;

	/////////////////////////
	hilf = doc->getDBs();
	//hilf = doc->getActualBase();

	DATABASES->clear();

	// Datenbanken einfgen:
	while( hilf ){
		// alle datenbanken durchlaufen...
		QListViewItem * temp = new QListViewItem(DATABASES);
		QString * datum = new QString( hilf->name );
		//QString * datum = new QString( doc->getActualBaseName() );

		//      // std::cout << "Update Main View: " << hilf->name << endl;

		temp->setText(0,*datum);
		DATABASES->insertItem( temp );

		table_t * hilf2 = NULL;
		///////////////////////////////
		hilf2 = hilf->table_list;
		//hilf2 = doc->getActualTable();

		delete datum; // hier gekilled
		// Tabellen einfgen:
		//	// std::cout << "...entering 'while hilf2'" << endl;
		while( hilf2 ){
			// alle tabellen der db durchlaufen...
			QString * datum2 = new QString( hilf2->name );
			//QString * datum2 = new QString( doc->getActualTableName() );
			QListViewItem * temp2 = new QListViewItem( temp );
			temp2->setText(0,*datum2);
			temp->insertItem( temp2 );

			// Spalten einfgen:
			column_t * hilf3 = NULL;
			////////////////////////////////
			hilf3 = hilf2->column_list;
			//hilf3 = doc->getActualColumn();

			delete datum2; // hier gekilled
			//      // std::cout << hilf3->name << endl;
			while(hilf3){
				//	    // std::cout << "...entering 'while hilf3'" << endl;
				//	    // std::cout << "hilf3->name" << hilf3->name << endl;


				QString * datum3 = new QString( hilf3->name );
				//QString * datum3 = new QString( doc->getActualTableName() );
				QString * datum4 = new QString( hilf3->type );
				//QString * datum4 = new QString( doc->getActualTableType() );
				//	    // std::cout << "created QString 3, 4" << endl;

				QChar * datum5 = new QChar( hilf3->pri );
				//QString * datum5 = new QString( *dat5 );
				QString * datum6 = new QString( hilf3->extra_flags );

				//	    // std::cout << "created QStrings" << endl;

				QListViewItem * temp3 = new QListViewItem( temp2 );
				//	    // std::cout << "setting temp3" << endl;
				temp3->setText(0,*datum3);
				temp3->setText(1,*datum4);
				temp3->setText(2,*datum5);
				temp3->setText(3,*datum6);
				temp2->insertItem( temp3 );

				////////////////////////////////
				if (hilf3) hilf3=hilf3->next;
				//doc->gotoNextColumn();
				//hilf3 = doc->getActualColumn();

				delete datum3; // hier gekilled
			}
			//	  // std::cout << "...end 'while hilf3'" << endl;

			//////////////////////
			hilf2 = hilf2->next;
			//doc->gotoNextTable();
			//hilf2 = doc->getActualTable();
		}
		//	// std::cout << "...end 'while hilf2'" << endl;

		////////////////////
		hilf = hilf->next;
		//doc->gotoNextBase();
		//hilf = doc->getActualBase();
	}
	//    // std::cout << "now calling repaint..." << endl;
	DATABASES->repaint();

}

void SqlGuiView::slotExport()
{
	//	ExportForm* frage = new ExportForm(this, "Export", TRUE, Qt::WType_Modal);
	// 	ExportBox* frage = new ExportBox(this, "Export", TRUE, Qt::WType_Modal);
	ExportBox* frage = new ExportBox(myParentWidget, "Export", TRUE, Qt::WType_Modal);

	connect( frage, SIGNAL( exportRequest(int, int) ), this, SLOT(slotExportDlg2( ) ) );
	connect( frage, SIGNAL( exportRequest(int, int) ), this, SLOT(slotSetExport(int, int) ) );
	frage->show();

}

void SqlGuiView::slotSetExport(int what, int form)
{
	// std::cout << "checked: " << what << " and " << form << endl;
	exportdata = what;

	switch (form){
		//		case 0: {exportform = EXCEL;break;}
	case 0: {exportform = TEXT;break;}
	case 1: {exportform = CSV;break;}
	case 2: {exportform = HTML;break;}
	case 3: {exportform = XML;break;}
	case 4: {exportform = POSTSCRIPT;break;}
	case 5: {exportform = TEX;break;}
	}
}

void SqlGuiView::slotExportDlg(int what, int form)
{
}



void SqlGuiView::slotExportDlg2()
{
	//	QFileDialog* whatfile2 = new QFileDialog(this, "Export-File", FALSE);
	whatfile2->show();
}


void SqlGuiView::slotWriteFile(){
	QString filename = whatfile2->selectedFile();
	QFile file( filename );
	if ( !file.exists() ){
		emit( overwrite( filename ) );
		// std::cout << "file doesnt exist... creating new one..." << endl;
		return;
	}

	if ( file.exists() ){
		// std::cout << "file exists!!!" << endl;
		switch( QMessageBox::information( myParentWidget, kl->translate( i18n("SqlGui Warning:")),
		                                  kl->translate( i18n("File exists\nDo you want to overwrite the file?")),
		                                  kl->translate( i18n("&Yes")), kl->translate( i18n("&No")), kl->translate( i18n("&Cancel")),
		                                  0,      // Enter == button 0
		                                  2 ) ) { // Escape == button 2
		case 0: {
				emit( overwrite( filename ) );
				// std::cout << "overwrite" << endl;
				break;}
		case 1:
			emit( donotoverwrite( filename ) );
			// std::cout << "not overwrite" << endl;
			break;
		case 2:
			break;
		}

	}
}

void SqlGuiView::slotConfirmOverwrite(const QString & filename){

	QFile file( filename );
	if ( !file.exists() ){
		emit( overwrite( filename ) );
		// std::cout << "file doesnt exist... creating new one..." << endl;
		return;
	}

	if ( file.exists() ){
		// std::cout << "file exists!!!" << endl;
		switch( QMessageBox::information( myParentWidget, kl->translate( i18n("SqlGui Warning:")),
		                                  kl->translate( i18n("File exists\nDo you want to overwrite the file?")),
		                                  kl->translate( i18n("&Yes")), kl->translate( i18n("&No")), kl->translate( i18n("&Cancel")),
		                                  0,      // Enter == button 0
		                                  2 ) ) { // Escape == button 2
		case 0: {
				emit( overwrite( filename ) );
				// std::cout << "overwrite" << endl;
				break;}
		case 1:
			emit( donotoverwrite( filename ) );
			// std::cout << "not overwrite" << endl;
			break;
		case 2:
			break;
		}

	}
}



void SqlGuiView::slotSelectExport( const QString & expfile )
{
	// std::cout << "Exportdata: " << exportdata << " and Exportform: " << exportform << endl;

	//	ExportObj* expo = new ExportObj(this,"Export");
	ExportObj* expo = new ExportObj(myParentWidget,"Export");

	expo->setFormat( exportform );

	switch (exportdata)
	{
	case 1:
		{
			// slotExportDB();
		}
	case 2:
		{
			// slotExportTable();
		}
	case 3:
		{
			QTableSelection* selection = new QTableSelection();
			selection = &(ResultList->selection(0));
			int oben = selection->topRow();
			int unten = selection->bottomRow();
			int links = selection->leftCol();
			int rechts = selection->rightCol();

			int zeilenOffset = oben;
			int spaltenOffset = links;

			//				// std::cout << "top: " << oben << " bottom: " << unten << " left: " << links << " right: " << rechts << endl;

			expo->setFilename( &expfile );
			expo->setTablename( getLastActionTab() );
			expo->setDBType( doc->getDBType() );
			expo->setRowOffset( zeilenOffset );
			expo->setColumnOffset( spaltenOffset );
			int tot = (unten-oben) * (rechts-links);

			QProgressDialog progress( kl->translate( i18n("Preparing data for export")), kl->translate( i18n("Abort export")), tot, myParentWidget, "progress", TRUE );

			// Alle selektierten Felder zeilenweise durchlaufen
			int prg = 0;
			column_t * spStart;
			spStart = doc->resultCols();
			for (int off=0; off<links; off++){
				spStart = spStart->next;
			}
			for (int zeile = oben; zeile <= unten; zeile++){
				column_t * sp = spStart;
				for (int spalte = links; spalte <= rechts; spalte++){
					// TODO: Spaltentyp festellen...!!!
					QString * dtype = new QString( sp->type );
					sp = sp->next;
					progress.setProgress( prg++ );
					expo->addData(zeile - zeilenOffset, spalte - spaltenOffset, &(ResultList->text(zeile,spalte)), dtype  );
				}
				if (progress.wasCancelled() ) break;
			}
			progress.setProgress( tot );
		}
	}

	expo->finish();
	delete expo;
}

QString * SqlGuiView::getLastActionDB(){
	return lastActionDB;
}
QString * SqlGuiView::getLastActionTab(){
	return lastActionTab;
}
QString * SqlGuiView::getLastActionPrim(){
	return lastActionPrim;
}

/*
void SqlGuiView::slotExportDB(QString* db, int format)
{
}
void SqlGuiView::slotExportTable(QString* db, QString* tb, int format)
{
}

void SqlGuiView::slotExportSelection( int row1, int col1, int row2, int col2, int format)
{
}
*/
